﻿Imports Microsoft.Reporting.WinForms
Imports System.Reflection
Imports System.Security.Permissions
Imports System.IO
Imports System.Drawing.Imaging
Imports System.Text

Public Class Berichtsverwaltung
    Dim Berichte As New List(Of String) From {{"externe Bilder"}, {"Bilder-Datenbank"}}

    Private Sub Berichtsverwaltung_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        FillDataSet()
        'PicturesDataSet.Pictures.WriteXml("Pictures.xml")
        cbxBerichte.Items.AddRange(Berichte.ToArray)
        cbxBerichte.SelectedIndex = 0
    End Sub

    Private Sub cbxBerichte_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cbxBerichte.SelectedIndexChanged
        Dim Bericht As String = getItem(CType(sender, ComboBox))
        With ReportViewer1
            .Reset() 'manchmal kommt es vor, dass die Berichtsparameter nicht mehr aufgelistet werden... (Achtung: SubReportProcessing-Ereignishandler wieder herstellen!)
            .LocalReport.EnableExternalImages = True
            .LocalReport.DataSources.Clear()
            If Bericht = "Bilder-Datenbank" Then bindReport(Bericht, "Pictures", PicturesBindingSource)
            .LocalReport.ReportEmbeddedResource = String.Concat("ReportViewerBilder.Report ", Bericht, ".rdlc")
            .LocalReport.SetParameters(New ReportParameter("rpPicturePath", Application.StartupPath))
            .RefreshReport()
        End With
    End Sub

    Private Sub bindReport(BerichtName As String, TableName As String, DataSource As Object)
        Dim rds As ReportDataSource = New ReportDataSource()
        rds.Name = TableName
        rds.Value = DataSource
        With ReportViewer1
            .LocalReport.DataSources.Add(rds)
            .LocalReport.ReportEmbeddedResource = String.Concat("ReportViewerBilder.Report ", BerichtName, ".rdlc")
            .RefreshReport()
        End With
    End Sub

    Private Function getItem(cbx As ComboBox) As String
        If cbx.SelectedItem Is Nothing Then Return String.Empty Else Return cbx.SelectedItem.ToString
    End Function

    Sub FillDataSet()
        PicturesDataSet.Pictures.Clear()
        Dim di As New DirectoryInfo(String.Concat(Application.StartupPath, "\../../Pictures/"))
        Dim picList = di.EnumerateFiles("*.jp*")
        For Each pic In picList
            Dim fi = pic.Name.Split("."c)
            Dim rw = PicturesDataSet.Pictures.NewPicturesRow
            rw.Name = fi(0)
            rw.Extension = fi(1)
            rw.BLOB = IMAGEtoBLOB(Bitmap.FromFile(pic.FullName))
            rw.MIME = BLOBtoMIME(rw.BLOB)
            PicturesDataSet.Pictures.AddPicturesRow(rw)
        Next
    End Sub

    Private Shared Function IMAGEtoBLOB(Image As Image) As Byte()
        Using ms As New MemoryStream()
            Image.Save(ms, ImageFormat.Jpeg)
            Return ms.ToArray()
        End Using
    End Function
    Private Function BLOBtoMIME(ByRef Bytes() As Byte) As String
        Return Convert.ToBase64String(Bytes)
    End Function
    'Private Shared Function BLOBtoIMAGE(Bytes As Byte()) As Image
    '    Using ms As New MemoryStream(Bytes)
    '        Dim returnImage As Image = Image.FromStream(ms)
    '        Return returnImage
    '    End Using
    'End Function
End Class